clan::ShaderEffectDescription Class Reference - ClanLib SDK
Description: clan::ShaderEffectDescription Class Reference

Public Member Functions | Friends | List of all members
clan::ShaderEffectDescription Class Reference
clanDisplay Display

Shader Effect Description. More...

`#include <shader_effect_description.h>`

## Public Member Functions
| ShaderEffectDescription ()
BlendStateDescription & | blend ()
DepthStencilStateDescription & | depth_stencil ()
RasterizerStateDescription & | rasterizer ()
void | set_attribute (std::string name, VertexArrayBuffer &buffer, int size, VertexAttributeDataType type, size_t offset=0, int stride=0, bool normalize=false)
void | set_attribute (std::string name, VertexArrayVector< char > &buffer, int size, bool normalize=false)
void | set_attribute (std::string name, VertexArrayVector< Colorf > &buffer)
void | set_attribute (std::string name, VertexArrayVector< float > &buffer)
void | set_attribute (std::string name, VertexArrayVector< float > &buffer, int size, bool normalize=false)
void | set_attribute (std::string name, VertexArrayVector< int > &buffer, int size, bool normalize=false)
void | set_attribute (std::string name, VertexArrayVector< short > &buffer, int size, bool normalize=false)
void | set_attribute (std::string name, VertexArrayVector< signed char > &buffer, bool normalize=false)
void | set_attribute (std::string name, VertexArrayVector< signed int > &buffer, bool normalize=false)
void | set_attribute (std::string name, VertexArrayVector< signed short > &buffer, bool normalize=false)
void | set_attribute (std::string name, VertexArrayVector< unsigned char > &buffer, bool normalize=false)
void | set_attribute (std::string name, VertexArrayVector< unsigned char > &buffer, int size, bool normalize=false)
void | set_attribute (std::string name, VertexArrayVector< unsigned int > &buffer, bool normalize=false)
void | set_attribute (std::string name, VertexArrayVector< unsigned int > &buffer, int size, bool normalize=false)
void | set_attribute (std::string name, VertexArrayVector< unsigned short > &buffer, bool normalize=false)
void | set_attribute (std::string name, VertexArrayVector< unsigned short > &buffer, int size, bool normalize=false)
void | set_attribute (std::string name, VertexArrayVector< Vec2b > &buffer, bool normalize=false)
void | set_attribute (std::string name, VertexArrayVector< Vec2f > &buffer)
void | set_attribute (std::string name, VertexArrayVector< Vec2i > &buffer, bool normalize=false)
void | set_attribute (std::string name, VertexArrayVector< Vec2s > &buffer, bool normalize=false)
void | set_attribute (std::string name, VertexArrayVector< Vec2ub > &buffer, bool normalize=false)
void | set_attribute (std::string name, VertexArrayVector< Vec2ui > &buffer, bool normalize=false)
void | set_attribute (std::string name, VertexArrayVector< Vec2us > &buffer, bool normalize=false)
void | set_attribute (std::string name, VertexArrayVector< Vec3b > &buffer, bool normalize=false)
void | set_attribute (std::string name, VertexArrayVector< Vec3f > &buffer)
void | set_attribute (std::string name, VertexArrayVector< Vec3i > &buffer, bool normalize=false)
void | set_attribute (std::string name, VertexArrayVector< Vec3s > &buffer, bool normalize=false)
void | set_attribute (std::string name, VertexArrayVector< Vec3ub > &buffer, bool normalize=false)
void | set_attribute (std::string name, VertexArrayVector< Vec3ui > &buffer, bool normalize=false)
void | set_attribute (std::string name, VertexArrayVector< Vec3us > &buffer, bool normalize=false)
void | set_attribute (std::string name, VertexArrayVector< Vec4b > &buffer, bool normalize=false)
void | set_attribute (std::string name, VertexArrayVector< Vec4f > &buffer)
void | set_attribute (std::string name, VertexArrayVector< Vec4i > &buffer, bool normalize=false)
void | set_attribute (std::string name, VertexArrayVector< Vec4s > &buffer, bool normalize=false)
void | set_attribute (std::string name, VertexArrayVector< Vec4ub > &buffer, bool normalize=false)
void | set_attribute (std::string name, VertexArrayVector< Vec4ui > &buffer, bool normalize=false)
void | set_attribute (std::string name, VertexArrayVector< Vec4us > &buffer, bool normalize=false)
void | set_attribute_screen_quad (std::string name)
void | set_attribute_uv_quad (std::string name)
void | set_compute_shader (std::string code, ShaderLanguage language=ShaderLanguage::glsl)
void | set_define (std::string name, std::string value="1")
void | set_depth_data (RenderBuffer buffer)
void | set_depth_data (Texture texture)
void | set_draw_count (int count)
void | set_elements (ElementArrayBuffer &element_array, VertexAttributeDataType indices_type)
void | set_elements (ElementArrayVector< unsigned char > &element_array)
void | set_elements (ElementArrayVector< unsigned int > &element_array)
void | set_elements (ElementArrayVector< unsigned short > &element_array)
void | set_frag_data (std::string name, RenderBuffer buffer)
void | set_frag_data (std::string name, Texture texture)
void | set_frag_data_to_back_buffer (std::string name)
void | set_fragment_shader (std::string code, ShaderLanguage language=ShaderLanguage::glsl)
void | set_glsl_version (int version=330)
void | set_image (std::string name, Resource< Texture > texture)
void | set_stencil_data (RenderBuffer buffer)
void | set_stencil_data (Texture texture)
void | set_storage (std::string name, Resource< StorageBuffer > values)
void | set_texture (std::string name, Resource< Texture > texture)
void | set_uniform_block (std::string name, Resource< UniformBuffer > values)
void | set_vertex_shader (std::string code, ShaderLanguage language=ShaderLanguage::glsl)

## Friends
class | ShaderEffect

## Detailed Description

Shader Effect Description.

...

## Constructor & Destructor Documentation

## ◆ ShaderEffectDescription()

clan::ShaderEffectDescription::ShaderEffectDescription | ( |  | ) |

## Member Function Documentation

## ◆ blend()

BlendStateDescription & clan::ShaderEffectDescription::blend | ( |  | ) |

## ◆ depth_stencil()

DepthStencilStateDescription & clan::ShaderEffectDescription::depth_stencil | ( |  | ) |

## ◆ rasterizer()

RasterizerStateDescription & clan::ShaderEffectDescription::rasterizer | ( |  | ) |

## ◆ set_attribute() [1/37]

void clan::ShaderEffectDescription::set_attribute | ( | std::string | name,
|  | VertexArrayBuffer & | buffer,
|  | int | size,
|  | VertexAttributeDataType | type,
|  | size_t | offset = 0,
|  | int | stride = 0,
|  | bool | normalize = false )

Referenced by set_attribute(), set_attribute(), set_attribute(), set_attribute(), set_attribute(), set_attribute(), set_attribute(), set_attribute(), set_attribute(), set_attribute(), set_attribute(), set_attribute(), set_attribute(), set_attribute(), set_attribute(), set_attribute(), set_attribute(), set_attribute(), set_attribute(), set_attribute(), set_attribute(), set_attribute(), set_attribute(), set_attribute(), set_attribute(), set_attribute(), set_attribute(), set_attribute(), set_attribute(), set_attribute(), set_attribute(), set_attribute(), set_attribute(), set_attribute(), set_attribute(), and set_attribute().

## ◆ set_attribute() [2/37]

void clan::ShaderEffectDescription::set_attribute | ( | std::string | name,
|  | VertexArrayVector< char > & | buffer,
|  | int | size,
|  | bool | normalize = false )
| inline

References set_attribute(), and clan::type_byte.

## ◆ set_attribute() [3/37]

void clan::ShaderEffectDescription::set_attribute | ( | std::string | name,
|  | VertexArrayVector< Colorf > & | buffer )
| inline

References set_attribute(), and clan::type_float.

## ◆ set_attribute() [4/37]

void clan::ShaderEffectDescription::set_attribute | ( | std::string | name,
|  | VertexArrayVector< float > & | buffer )
| inline

References set_attribute(), and clan::type_float.

## ◆ set_attribute() [5/37]

void clan::ShaderEffectDescription::set_attribute | ( | std::string | name,
|  | VertexArrayVector< float > & | buffer,
|  | int | size,
|  | bool | normalize = false )
| inline

References set_attribute(), and clan::type_float.

## ◆ set_attribute() [6/37]

void clan::ShaderEffectDescription::set_attribute | ( | std::string | name,
|  | VertexArrayVector< int > & | buffer,
|  | int | size,
|  | bool | normalize = false )
| inline

References set_attribute(), and clan::type_int.

## ◆ set_attribute() [7/37]

void clan::ShaderEffectDescription::set_attribute | ( | std::string | name,
|  | VertexArrayVector< short > & | buffer,
|  | int | size,
|  | bool | normalize = false )
| inline

References set_attribute(), and clan::type_short.

## ◆ set_attribute() [8/37]

void clan::ShaderEffectDescription::set_attribute | ( | std::string | name,
|  | VertexArrayVector< signed char > & | buffer,
|  | bool | normalize = false )
| inline

References set_attribute(), and clan::type_byte.

## ◆ set_attribute() [9/37]

void clan::ShaderEffectDescription::set_attribute | ( | std::string | name,
|  | VertexArrayVector< signed int > & | buffer,
|  | bool | normalize = false )
| inline

References set_attribute(), and clan::type_int.

## ◆ set_attribute() [10/37]

void clan::ShaderEffectDescription::set_attribute | ( | std::string | name,
|  | VertexArrayVector< signed short > & | buffer,
|  | bool | normalize = false )
| inline

References set_attribute(), and clan::type_short.

## ◆ set_attribute() [11/37]

void clan::ShaderEffectDescription::set_attribute | ( | std::string | name,
|  | VertexArrayVector< unsigned char > & | buffer,
|  | bool | normalize = false )
| inline

References set_attribute(), and clan::type_unsigned_byte.

## ◆ set_attribute() [12/37]

void clan::ShaderEffectDescription::set_attribute | ( | std::string | name,
|  | VertexArrayVector< unsigned char > & | buffer,
|  | int | size,
|  | bool | normalize = false )
| inline

References set_attribute(), and clan::type_unsigned_byte.

## ◆ set_attribute() [13/37]

void clan::ShaderEffectDescription::set_attribute | ( | std::string | name,
|  | VertexArrayVector< unsigned int > & | buffer,
|  | bool | normalize = false )
| inline

References set_attribute(), and clan::type_unsigned_int.

## ◆ set_attribute() [14/37]

void clan::ShaderEffectDescription::set_attribute | ( | std::string | name,
|  | VertexArrayVector< unsigned int > & | buffer,
|  | int | size,
|  | bool | normalize = false )
| inline

References set_attribute(), and clan::type_unsigned_int.

## ◆ set_attribute() [15/37]

void clan::ShaderEffectDescription::set_attribute | ( | std::string | name,
|  | VertexArrayVector< unsigned short > & | buffer,
|  | bool | normalize = false )
| inline

References set_attribute(), and clan::type_unsigned_short.

## ◆ set_attribute() [16/37]

void clan::ShaderEffectDescription::set_attribute | ( | std::string | name,
|  | VertexArrayVector< unsigned short > & | buffer,
|  | int | size,
|  | bool | normalize = false )
| inline

References set_attribute(), and clan::type_unsigned_short.

## ◆ set_attribute() [17/37]

void clan::ShaderEffectDescription::set_attribute | ( | std::string | name,
|  | VertexArrayVector< Vec2b > & | buffer,
|  | bool | normalize = false )
| inline

References set_attribute(), and clan::type_byte.

## ◆ set_attribute() [18/37]

void clan::ShaderEffectDescription::set_attribute | ( | std::string | name,
|  | VertexArrayVector< Vec2f > & | buffer )
| inline

References set_attribute(), and clan::type_float.

## ◆ set_attribute() [19/37]

void clan::ShaderEffectDescription::set_attribute | ( | std::string | name,
|  | VertexArrayVector< Vec2i > & | buffer,
|  | bool | normalize = false )
| inline

References set_attribute(), and clan::type_int.

## ◆ set_attribute() [20/37]

void clan::ShaderEffectDescription::set_attribute | ( | std::string | name,
|  | VertexArrayVector< Vec2s > & | buffer,
|  | bool | normalize = false )
| inline

References set_attribute(), and clan::type_short.

## ◆ set_attribute() [21/37]

void clan::ShaderEffectDescription::set_attribute | ( | std::string | name,
|  | VertexArrayVector< Vec2ub > & | buffer,
|  | bool | normalize = false )
| inline

References set_attribute(), and clan::type_unsigned_byte.

## ◆ set_attribute() [22/37]

void clan::ShaderEffectDescription::set_attribute | ( | std::string | name,
|  | VertexArrayVector< Vec2ui > & | buffer,
|  | bool | normalize = false )
| inline

References set_attribute(), and clan::type_unsigned_int.

## ◆ set_attribute() [23/37]

void clan::ShaderEffectDescription::set_attribute | ( | std::string | name,
|  | VertexArrayVector< Vec2us > & | buffer,
|  | bool | normalize = false )
| inline

References set_attribute(), and clan::type_unsigned_short.

## ◆ set_attribute() [24/37]

void clan::ShaderEffectDescription::set_attribute | ( | std::string | name,
|  | VertexArrayVector< Vec3b > & | buffer,
|  | bool | normalize = false )
| inline

References set_attribute(), and clan::type_byte.

## ◆ set_attribute() [25/37]

void clan::ShaderEffectDescription::set_attribute | ( | std::string | name,
|  | VertexArrayVector< Vec3f > & | buffer )
| inline

References set_attribute(), and clan::type_float.

## ◆ set_attribute() [26/37]

void clan::ShaderEffectDescription::set_attribute | ( | std::string | name,
|  | VertexArrayVector< Vec3i > & | buffer,
|  | bool | normalize = false )
| inline

References set_attribute(), and clan::type_int.

## ◆ set_attribute() [27/37]

void clan::ShaderEffectDescription::set_attribute | ( | std::string | name,
|  | VertexArrayVector< Vec3s > & | buffer,
|  | bool | normalize = false )
| inline

References set_attribute(), and clan::type_short.

## ◆ set_attribute() [28/37]

void clan::ShaderEffectDescription::set_attribute | ( | std::string | name,
|  | VertexArrayVector< Vec3ub > & | buffer,
|  | bool | normalize = false )
| inline

References set_attribute(), and clan::type_unsigned_byte.

## ◆ set_attribute() [29/37]

void clan::ShaderEffectDescription::set_attribute | ( | std::string | name,
|  | VertexArrayVector< Vec3ui > & | buffer,
|  | bool | normalize = false )
| inline

References set_attribute(), and clan::type_unsigned_int.

## ◆ set_attribute() [30/37]

void clan::ShaderEffectDescription::set_attribute | ( | std::string | name,
|  | VertexArrayVector< Vec3us > & | buffer,
|  | bool | normalize = false )
| inline

References set_attribute(), and clan::type_unsigned_short.

## ◆ set_attribute() [31/37]

void clan::ShaderEffectDescription::set_attribute | ( | std::string | name,
|  | VertexArrayVector< Vec4b > & | buffer,
|  | bool | normalize = false )
| inline

References set_attribute(), and clan::type_byte.

## ◆ set_attribute() [32/37]

void clan::ShaderEffectDescription::set_attribute | ( | std::string | name,
|  | VertexArrayVector< Vec4f > & | buffer )
| inline

References set_attribute(), and clan::type_float.

## ◆ set_attribute() [33/37]

void clan::ShaderEffectDescription::set_attribute | ( | std::string | name,
|  | VertexArrayVector< Vec4i > & | buffer,
|  | bool | normalize = false )
| inline

References set_attribute(), and clan::type_int.

## ◆ set_attribute() [34/37]

void clan::ShaderEffectDescription::set_attribute | ( | std::string | name,
|  | VertexArrayVector< Vec4s > & | buffer,
|  | bool | normalize = false )
| inline

References set_attribute(), and clan::type_short.

## ◆ set_attribute() [35/37]

void clan::ShaderEffectDescription::set_attribute | ( | std::string | name,
|  | VertexArrayVector< Vec4ub > & | buffer,
|  | bool | normalize = false )
| inline

References set_attribute(), and clan::type_unsigned_byte.

## ◆ set_attribute() [36/37]

void clan::ShaderEffectDescription::set_attribute | ( | std::string | name,
|  | VertexArrayVector< Vec4ui > & | buffer,
|  | bool | normalize = false )
| inline

References set_attribute(), and clan::type_unsigned_int.

## ◆ set_attribute() [37/37]

void clan::ShaderEffectDescription::set_attribute | ( | std::string | name,
|  | VertexArrayVector< Vec4us > & | buffer,
|  | bool | normalize = false )
| inline

References set_attribute(), and clan::type_unsigned_short.

## ◆ set_attribute_screen_quad()

void clan::ShaderEffectDescription::set_attribute_screen_quad | ( | std::string | name | ) |

## ◆ set_attribute_uv_quad()

void clan::ShaderEffectDescription::set_attribute_uv_quad | ( | std::string | name | ) |

## ◆ set_compute_shader()

void clan::ShaderEffectDescription::set_compute_shader | ( | std::string | code,
|  | ShaderLanguage | language = ShaderLanguage::glsl )

References clan::glsl.

## ◆ set_define()

void clan::ShaderEffectDescription::set_define | ( | std::string | name,
|  | std::string | value = "1" )

## ◆ set_depth_data() [1/2]

void clan::ShaderEffectDescription::set_depth_data | ( | RenderBuffer | buffer | ) |

## ◆ set_depth_data() [2/2]

void clan::ShaderEffectDescription::set_depth_data | ( | Texture | texture | ) |

## ◆ set_draw_count()

void clan::ShaderEffectDescription::set_draw_count | ( | int | count | ) |

## ◆ set_elements() [1/4]

void clan::ShaderEffectDescription::set_elements | ( | ElementArrayBuffer & | element_array,
|  | VertexAttributeDataType | indices_type )

Referenced by set_elements(), set_elements(), and set_elements().

## ◆ set_elements() [2/4]

void clan::ShaderEffectDescription::set_elements | ( | ElementArrayVector< unsigned char > & | element_array | ) |
| inline

References set_elements(), and clan::type_unsigned_byte.

## ◆ set_elements() [3/4]

void clan::ShaderEffectDescription::set_elements | ( | ElementArrayVector< unsigned int > & | element_array | ) |
| inline

References set_elements(), and clan::type_unsigned_int.

## ◆ set_elements() [4/4]

void clan::ShaderEffectDescription::set_elements | ( | ElementArrayVector< unsigned short > & | element_array | ) |
| inline

References set_elements(), and clan::type_unsigned_short.

## ◆ set_frag_data() [1/2]

void clan::ShaderEffectDescription::set_frag_data | ( | std::string | name,
|  | RenderBuffer | buffer )

## ◆ set_frag_data() [2/2]

void clan::ShaderEffectDescription::set_frag_data | ( | std::string | name,
|  | Texture | texture )

## ◆ set_frag_data_to_back_buffer()

void clan::ShaderEffectDescription::set_frag_data_to_back_buffer | ( | std::string | name | ) |

## ◆ set_fragment_shader()

void clan::ShaderEffectDescription::set_fragment_shader | ( | std::string | code,
|  | ShaderLanguage | language = ShaderLanguage::glsl )

References clan::glsl.

## ◆ set_glsl_version()

void clan::ShaderEffectDescription::set_glsl_version | ( | int | version = 330 | ) |

## ◆ set_image()

void clan::ShaderEffectDescription::set_image | ( | std::string | name,
|  | Resource< Texture > | texture )

## ◆ set_stencil_data() [1/2]

void clan::ShaderEffectDescription::set_stencil_data | ( | RenderBuffer | buffer | ) |

## ◆ set_stencil_data() [2/2]

void clan::ShaderEffectDescription::set_stencil_data | ( | Texture | texture | ) |

## ◆ set_storage()

void clan::ShaderEffectDescription::set_storage | ( | std::string | name,
|  | Resource< StorageBuffer > | values )

## ◆ set_texture()

void clan::ShaderEffectDescription::set_texture | ( | std::string | name,
|  | Resource< Texture > | texture )

## ◆ set_uniform_block()

void clan::ShaderEffectDescription::set_uniform_block | ( | std::string | name,
|  | Resource< UniformBuffer > | values )

## ◆ set_vertex_shader()

void clan::ShaderEffectDescription::set_vertex_shader | ( | std::string | code,
|  | ShaderLanguage | language = ShaderLanguage::glsl )

References clan::glsl.

## Friends And Related Symbol Documentation

## ◆ ShaderEffect

friend class ShaderEffect
| friend

References ShaderEffect.

Referenced by ShaderEffect.

The documentation for this class was generated from the following file:

- shader_effect_description.h